import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGoodsOrder, ThinkGoodsOrderParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkGoodsOrder(params: ThinkGoodsOrderParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGoodsOrder>>>(
    THINK_API_URL + '/think/think-goods-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkGoodsOrder(params?: ThinkGoodsOrderParam) {
  const res = await request.get<ApiResult<ThinkGoodsOrder[]>>(
    THINK_API_URL + '/think/think-goods-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkGoodsOrder(data: ThinkGoodsOrder) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkGoodsOrder(data: ThinkGoodsOrder) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkGoodsOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkGoodsOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkGoodsOrder(id: number) {
  const res = await request.get<ApiResult<ThinkGoodsOrder>>(
    THINK_API_URL + '/think/think-goods-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
